Index: expr.c
===================================================================
--- expr.c	(revision 198625)
+++ expr.c	(working copy)
@@ -1,645 +1,43 @@
-/*	$OpenBSD: expr.c,v 1.14 2002/04/26 16:15:16 espie Exp $	*/
-/*	$NetBSD: expr.c,v 1.7 1995/09/28 05:37:31 tls Exp $	*/
-
+/* $OpenBSD: expr.c,v 1.17 2006/01/20 23:10:19 espie Exp $ */
 /*
- * Copyright (c) 1989, 1993
- *	The Regents of the University of California.  All rights reserved.
+ * Copyright (c) 2004 Marc Espie <espie@cvs.openbsd.org>
  *
- * This code is derived from software contributed to Berkeley by
- * Ozan Yigit at York University.
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
  *
- * Redistribution and use in source and binary forms, with or without
- * modification, are permitted provided that the following conditions
- * are met:
- * 1. Redistributions of source code must retain the above copyright
- *    notice, this list of conditions and the following disclaimer.
- * 2. Redistributions in binary form must reproduce the above copyright
- *    notice, this list of conditions and the following disclaimer in the
- *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
- *    may be used to endorse or promote products derived from this software
- *    without specific prior written permission.
- *
- * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
- * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
- * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
- * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
- * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
- * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
- * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
- * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
- * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
- * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
- * SUCH DAMAGE.
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
  */
-
-#ifndef lint
-#if 0
-static char sccsid[] = "@(#)expr.c	8.2 (Berkeley) 4/29/95";
-#else
-#if 0
-static char rcsid[] = "$OpenBSD: expr.c,v 1.14 2002/04/26 16:15:16 espie Exp $";
-#endif
-#endif
-#endif /* not lint */
-
-#include <sys/cdefs.h>
-__FBSDID("$FreeBSD$");
-
-#include <sys/types.h>
-#include <ctype.h>
-#include <err.h>
-#include <stddef.h>
+#include <stdint.h>
 #include <stdio.h>
+#include <stddef.h>
 #include "mdef.h"
 #include "extern.h"
 
-/*
- *      expression evaluator: performs a standard recursive
- *      descent parse to evaluate any expression permissible
- *      within the following grammar:
- *
- *      expr    :       query EOS
- *      query   :       lor
- *              |       lor "?" query ":" query
- *      lor     :       land { "||" land }
- *      land    :       bor { "&&" bor }
- *      bor     :       xor { "|" xor }
- *      xor     :       band { "^" eqrel }
- *      band    :       eqrel { "&" eqrel }
- *      eqrel   :       nerel { ("==" | "!=") nerel }
- *      nerel   :       shift { ("<" | ">" | "<=" | ">=") shift }
- *      shift   :       primary { ("<<" | ">>") primary }
- *      primary :       term { ("+" | "-") term }
- *      term    :       exp { ("*" | "/" | "%") exp }
- *      exp     :       unary { "**" unary }
- *      unary   :       factor
- *              |       ("+" | "-" | "~" | "!") unary
- *      factor  :       constant
- *              |       "(" query ")"
- *      constant:       num
- *              |       "'" CHAR "'"
- *      num     :       DIGIT
- *              |       DIGIT num
- *
- *
- *      This expression evaluator is lifted from a public-domain
- *      C Pre-Processor included with the DECUS C Compiler distribution.
- *      It is hacked somewhat to be suitable for m4.
- *
- *      Originally by:  Mike Lutz
- *                      Bob Harper
- */
+int32_t end_result;
+const char *copy_toeval;
 
-#define EQL     0
-#define NEQ     1
-#define LSS     2
-#define LEQ     3
-#define GTR     4
-#define GEQ     5
-#define OCTAL   8
-#define DECIMAL 10
-#define HEX	16
+extern void yy_scan_string(const char *);
+extern int yyparse(void);
 
-static const char *nxtch;		       /* Parser scan pointer */
-static const char *where;
-
-static int query(int mayeval);
-static int lor(int mayeval);
-static int land(int mayeval);
-static int bor(int mayeval);
-static int xor(int mayeval);
-static int band(int mayeval);
-static int eqrel(int mayeval);
-static int nerel(int mayeval);
-static int shift(int mayeval);
-static int primary(int mayeval);
-static int term(int mayeval);
-static int exp(int mayeval);
-static int unary(int mayeval);
-static int factor(int mayeval);
-static int constant(int mayeval);
-static int num(int mayeval);
-static int geteqrel(int mayeval);
-static int skipws(void);
-static void experr(const char *);
-
-/*
- * For longjmp
- */
-#include <setjmp.h>
-static jmp_buf expjump;
-
-/*
- * macros:
- *      ungetch - Put back the last character examined.
- *      getch   - return the next character from expr string.
- */
-#define ungetch()       nxtch--
-#define getch()         *nxtch++
-
 int
-expr(const char *expbuf)
+yyerror(const char *msg)
 {
-	int rval;
-
-	nxtch = expbuf;
-	where = expbuf;
-	if (setjmp(expjump) != 0)
-		return FALSE;
-
-	rval = query(1);
-	if (skipws() == EOS)
-		return rval;
-
-	printf("m4: ill-formed expression.\n");
-	return FALSE;
+	fprintf(stderr, "m4: %s in expr %s\n", msg, copy_toeval);
+	return(0);
 }
 
-/*
- * query : lor | lor '?' query ':' query
- */
-static int
-query(int mayeval)
+int 
+expr(const char *toeval)
 {
-	int result, true_val, false_val;
-
-	result = lor(mayeval);
-	if (skipws() != '?') {
-		ungetch();
-		return result;
-	}
-
-	true_val = query(result);
-	if (skipws() != ':')
-		experr("bad query: missing \":\"");
-
-	false_val = query(!result);
-	return result ? true_val : false_val;
+	copy_toeval = toeval;
+	yy_scan_string(toeval);
+	yyparse();
+	return end_result;
 }
-
-/*
- * lor : land { '||' land }
- */
-static int
-lor(int mayeval)
-{
-	int c, vl, vr;
-
-	vl = land(mayeval);
-	while ((c = skipws()) == '|') {
-		if (getch() != '|') {
-			ungetch();
-			break;
-		}
-		if (vl != 0)
-			mayeval = 0;
-		vr = land(mayeval);
-		vl = vl || vr;
-	}
-
-	ungetch();
-	return vl;
-}
-
-/*
- * land : not { '&&' not }
- */
-static int
-land(int mayeval)
-{
-	int c, vl, vr;
-
-	vl = bor(mayeval);
-	while ((c = skipws()) == '&') {
-		if (getch() != '&') {
-			ungetch();
-			break;
-		}
-		if (vl == 0)
-			mayeval = 0;
-		vr = bor(mayeval);
-		vl = vl && vr;
-	}
-
-	ungetch();
-	return vl;
-}
-
-/*
- * bor : xor { "|" xor }
- */
-static int
-bor(int mayeval)
-{
-	int vl, vr, c, cr;
-
-	vl = xor(mayeval);
-	while ((c = skipws()) == '|') {
-		cr = getch();
-		ungetch();
-		if (cr == '|')
-			break;
-		vr = xor(mayeval);
-		vl |= vr;
-	}
-	ungetch();
-	return (vl);
-}
-
-/*
- * xor : band { "^" band }
- */
-static int
-xor(int mayeval)
-{
-	int vl, vr, c;
-
-	vl = band(mayeval);
-	while ((c = skipws()) == '^') {
-		vr = band(mayeval);
-		vl ^= vr;
-	}
-	ungetch();
-	return (vl);
-}
-
-/*
- * band : eqrel { "&" eqrel }
- */
-static int
-band(int mayeval)
-{
-	int c, cr, vl, vr;
-
-	vl = eqrel(mayeval);
-	while ((c = skipws()) == '&') {
-		cr = getch();
-		ungetch();
-		if (cr == '&')
-			break;
-		vr = eqrel(mayeval);
-		vl &= vr;
-	}
-	ungetch();
-	return vl;
-}
-
-/*
- * eqrel : nerel { ("==" | "!=" ) nerel }
- */
-static int
-eqrel(int mayeval)
-{
-	int vl, vr, c, cr;
-
-	vl = nerel(mayeval);
-	while ((c = skipws()) == '!' || c == '=') {
-		if ((cr = getch()) != '=') {
-			ungetch();
-			break;
-		}
-		vr = nerel(mayeval);
-		switch (c) {
-		case '=':
-			vl = (vl == vr);
-			break;
-		case '!':
-			vl = (vl != vr);
-			break;
-		}
-	}
-	ungetch();
-	return vl;
-}
-
-/*
- * nerel : shift { ("<=" | ">=" | "<" | ">") shift }
- */
-static int
-nerel(int mayeval)
-{
-	int vl, vr, c, cr;
-
-	vl = shift(mayeval);
-	while ((c = skipws()) == '<' || c == '>') {
-		if ((cr = getch()) != '=') {
-			ungetch();
-			cr = '\0';
-		}
-		vr = shift(mayeval);
-		switch (c) {
-		case '<':
-			vl = (cr == '\0') ? (vl < vr) : (vl <= vr);
-			break;
-		case '>':
-			vl = (cr == '\0') ? (vl > vr) : (vl >= vr);
-			break;
-		}
-	}
-	ungetch();
-	return vl;
-}
-
-/*
- * shift : primary { ("<<" | ">>") primary }
- */
-static int
-shift(int mayeval)
-{
-	int vl, vr, c;
-
-	vl = primary(mayeval);
-	while (((c = skipws()) == '<' || c == '>') && getch() == c) {
-		vr = primary(mayeval);
-
-		if (c == '<')
-			vl <<= vr;
-		else
-			vl >>= vr;
-	}
-
-	if (c == '<' || c == '>')
-		ungetch();
-	ungetch();
-	return vl;
-}
-
-/*
- * primary : term { ("+" | "-") term }
- */
-static int
-primary(int mayeval)
-{
-	int c, vl, vr;
-
-	vl = term(mayeval);
-	while ((c = skipws()) == '+' || c == '-') {
-		vr = term(mayeval);
-
-		if (c == '+')
-			vl += vr;
-		else
-			vl -= vr;
-	}
-
-	ungetch();
-	return vl;
-}
-
-/*
- * term : exp { ("*" | "/" | "%") exp }
- */
-static int
-term(int mayeval)
-{
-	int c, vl, vr;
-
-	vl = exp(mayeval);
-	while ((c = skipws()) == '*' || c == '/' || c == '%') {
-		vr = exp(mayeval);
-
-		switch (c) {
-		case '*':
-			vl *= vr;
-			break;
-		case '/':
-			if (!mayeval)
-				/* short-circuit */;
-			else if (vr == 0)
-				errx(1, "division by zero in eval.");
-			else
-				vl /= vr;
-			break;
-		case '%':
-			if (!mayeval)
-				/* short-circuit */;
-			else if (vr == 0)
-				errx(1, "modulo zero in eval.");
-			else
-				vl %= vr;
-			break;
-		}
-	}
-	ungetch();
-	return vl;
-}
-
-/*
- * exp : unary { "**" exp }
- */
-static int
-exp(int mayeval)
-{
-	int c, vl, vr, n;
-
-	vl = unary(mayeval);
-	while ((c = skipws()) == '*') {
-		if (getch() != '*') {
-			ungetch();
-			break;
-		}
-		vr = unary(mayeval);
-		n = 1;
-		while (vr-- > 0)
-			n *= vl;
-		return n;
-	}
-
-	ungetch();
-	return vl;
-}
-
-/*
- * unary : factor | ("+" | "-" | "~" | "!") unary
- */
-static int
-unary(int mayeval)
-{
-	int val, c;
-
-	if ((c = skipws()) == '+' || c == '-' || c == '~' || c == '!') {
-		val = unary(mayeval);
-
-		switch (c) {
-		case '+':
-			return val;
-		case '-':
-			return -val;
-		case '~':
-			return ~val;
-		case '!':
-			return !val;
-		}
-	}
-
-	ungetch();
-	return factor(mayeval);
-}
-
-/*
- * factor : constant | '(' query ')'
- */
-static int
-factor(int mayeval)
-{
-	int val;
-
-	if (skipws() == '(') {
-		val = query(mayeval);
-		if (skipws() != ')')
-			experr("bad factor: missing \")\"");
-		return val;
-	}
-
-	ungetch();
-	return constant(mayeval);
-}
-
-/*
- * constant: num | 'char'
- * Note: constant() handles multi-byte constants
- */
-static int
-constant(int mayeval)
-{
-	int i;
-	int value;
-	int c;
-	int v[sizeof(int)];
-
-	if (skipws() != '\'') {
-		ungetch();
-		return num(mayeval);
-	}
-	for (i = 0; i < (ssize_t)sizeof(int); i++) {
-		if ((c = getch()) == '\'') {
-			ungetch();
-			break;
-		}
-		if (c == '\\') {
-			switch (c = getch()) {
-			case '0':
-			case '1':
-			case '2':
-			case '3':
-			case '4':
-			case '5':
-			case '6':
-			case '7':
-				ungetch();
-				c = num(mayeval);
-				break;
-			case 'n':
-				c = 012;
-				break;
-			case 'r':
-				c = 015;
-				break;
-			case 't':
-				c = 011;
-				break;
-			case 'b':
-				c = 010;
-				break;
-			case 'f':
-				c = 014;
-				break;
-			}
-		}
-		v[i] = c;
-	}
-	if (i == 0 || getch() != '\'')
-		experr("illegal character constant");
-	for (value = 0; --i >= 0;) {
-		value <<= 8;
-		value += v[i];
-	}
-	return value;
-}
-
-/*
- * num : digit | num digit
- */
-static int
-num(int mayeval)
-{
-	int rval, c, base;
-	int ndig;
-
-	rval = 0;
-	ndig = 0;
-	c = skipws();
-	if (c == '0') {
-		c = skipws();
-		if (c == 'x' || c == 'X') {
-			base = HEX;
-			c = skipws();
-		} else {
-			base = OCTAL;
-			ndig++;
-		}
-	} else
-		base = DECIMAL;
-	for(;;) {
-		switch(c) {
-			case '8': case '9':
-				if (base == OCTAL)
-					goto bad_digit;
-				/*FALLTHRU*/
-			case '0': case '1': case '2': case '3':
-			case '4': case '5': case '6': case '7':
-				rval *= base;
-				rval += c - '0';
-				break;
-			case 'A': case 'B': case 'C': case 'D': case 'E': case 'F':
-				c = tolower(c);
-			case 'a': case 'b': case 'c': case 'd': case 'e': case 'f':
-				if (base == HEX) {
-					rval *= base;
-					rval += c - 'a' + 10;
-					break;
-				}
-				/*FALLTHRU*/
-			default:
-				goto bad_digit;
-		}
-		c = getch();
-		ndig++;
-	}
-bad_digit:
-	ungetch();
-
-	if (ndig == 0)
-		experr("bad constant");
-
-	return rval;
-}
-
-/*
- * Skip over any white space and return terminating char.
- */
-static int
-skipws(void)
-{
-	int c;
-
-	while ((c = getch()) <= ' ' && c > EOS)
-		;
-	return c;
-}
-
-/*
- * resets environment to eval(), prints an error
- * and forces eval to return FALSE.
- */
-static void
-experr(const char *msg)
-{
-	printf("m4: %s in expr %s.\n", msg, where);
-	longjmp(expjump, -1);
-}
Index: mdef.h
===================================================================
--- mdef.h	(revision 198625)
+++ mdef.h	(working copy)
@@ -1,4 +1,4 @@
-/*	$OpenBSD: mdef.h,v 1.21 2001/09/27 11:40:33 espie Exp $	*/
+/*	$OpenBSD: mdef.h,v 1.29 2006/03/20 20:27:45 espie Exp $	*/
 /*	$NetBSD: mdef.h,v 1.7 1996/01/13 23:25:27 pk Exp $	*/
 
 /*
@@ -16,11 +16,7 @@
  * 2. Redistributions in binary form must reproduce the above copyright
  *    notice, this list of conditions and the following disclaimer in the
  *    documentation and/or other materials provided with the distribution.
- * 3. All advertising materials mentioning features or use of this software
- *    must display the following acknowledgement:
- *	This product includes software developed by the University of
- *	California, Berkeley and its contributors.
- * 4. Neither the name of the University nor the names of its contributors
+ * 3. Neither the name of the University nor the names of its contributors
  *    may be used to endorse or promote products derived from this software
  *    without specific prior written permission.
  *
@@ -37,9 +33,14 @@
  * SUCH DAMAGE.
  *
  *	@(#)mdef.h	8.1 (Berkeley) 6/6/93
- * $FreeBSD$
  */
 
+#ifdef __GNUC__
+# define UNUSED	__attribute__((__unused__))
+#else
+# define UNUSED
+#endif
+
 #define MACRTYPE        1
 #define DEFITYPE        2
 #define EXPRTYPE        3
@@ -83,8 +84,10 @@
 #define ESYSCMDTYPE	41
 #define TRACEONTYPE	42
 #define TRACEOFFTYPE	43
+#define FORMATTYPE	44
 
-
+#define BUILTIN_MARKER	"__builtin_"
+ 
 #define TYPEMASK	63	/* Keep bits really corresponding to a type. */
 #define RECDEF		256	/* Pure recursive def, don't expand it */
 #define NOARGS		512	/* builtin needs no args */
@@ -93,7 +96,7 @@
 /*
  * m4 special characters
  */
-
+ 
 #define ARGFLAG         '$'
 #define LPAREN          '('
 #define RPAREN          ')'
@@ -120,10 +123,10 @@
 #define MAXTOK          512          	/* maximum chars in a tokn 	    */
 #define HASHSIZE        199             /* maximum size of hashtab 	    */
 #define MAXCCHARS	5		/* max size of comment/quote delim  */
-
+ 
 #define ALL             1
 #define TOP             0
-
+ 
 #define TRUE            1
 #define FALSE           0
 #define cycle           for(;;)
@@ -131,24 +134,23 @@
 /*
  * m4 data structures
  */
-
+ 
 typedef struct ndblock *ndptr;
-
-struct ndblock {		/* hastable structure         */
-	char		*name;	/* entry name..               */
+ 
+struct macro_definition {
+	struct macro_definition *next;
 	char		*defn;	/* definition..               */
 	unsigned int	type;	/* type of the entry..        */
-	unsigned int 	hv;	/* hash function value..      */
-	ndptr		nxtptr;	/* link to next entry..       */
 };
 
-#define nil     ((ndptr) 0)
 
-struct keyblk {
-        const char    *knam;    /* keyword name */
-        int     ktyp;           /* keyword type */
+struct ndblock {			/* hashtable structure         */
+	unsigned int 		builtin_type;
+	unsigned int		trace_flags;
+	struct macro_definition *d;
+	char		name[1];	/* entry name..               */
 };
-
+ 
 typedef union {			/* stack structure */
 	int	sfra;		/* frame entry  */
 	char 	*sstr;		/* string entry */
@@ -158,6 +160,7 @@
 	FILE 		*file;
 	char 		*name;
 	unsigned long 	lineno;
+	unsigned long   synch_lineno;	/* used for -s */
 	int 		c;
 };
 
@@ -166,31 +169,33 @@
 /*
  * macros for readibility and/or speed
  *
+ *      gpbc()  - get a possibly pushed-back character
  *      pushf() - push a call frame entry onto stack
  *      pushs() - push a string pointer onto stack
  */
-#define pushf(x) 					\
-	do {						\
-		if ((uintptr_t)++sp == STACKMAX) 	\
-			enlarge_stack();		\
-		mstack[sp].sfra = (x);			\
-		sstack[sp] = 0;				\
+#define gpbc() 	 (bp > bufbase) ? *--bp : obtain_char(infile+ilevel)
+#define pushf(x) 			\
+	do {				\
+		if (++sp == STACKMAX) 	\
+			enlarge_stack();\
+		mstack[sp].sfra = (x);	\
+		sstack[sp] = 0; \
 	} while (0)
 
-#define pushs(x) 					\
-	do {						\
-		if ((uintptr_t)++sp == STACKMAX) 	\
-			enlarge_stack();		\
-		mstack[sp].sstr = (x);			\
-		sstack[sp] = 1;				\
+#define pushs(x) 			\
+	do {				\
+		if (++sp == STACKMAX) 	\
+			enlarge_stack();\
+		mstack[sp].sstr = (x);	\
+		sstack[sp] = 1; \
 	} while (0)
 
-#define pushs1(x) 					\
-	do {						\
-		if ((uintptr_t)++sp == STACKMAX) 	\
-			enlarge_stack();		\
-		mstack[sp].sstr = (x);			\
-		sstack[sp] = 0;				\
+#define pushs1(x) 			\
+	do {				\
+		if (++sp == STACKMAX) 	\
+			enlarge_stack();\
+		mstack[sp].sstr = (x);	\
+		sstack[sp] = 0; \
 	} while (0)
 
 /*
@@ -217,7 +222,8 @@
  *
  */
 #define PARLEV  (mstack[fp].sfra)
-#define CALTYP  (mstack[fp-1].sfra)
+#define CALTYP  (mstack[fp-2].sfra)
+#define TRACESTATUS (mstack[fp-1].sfra)
 #define PREVEP	(mstack[fp+3].sstr)
-#define PREVSP	(fp-3)
-#define PREVFP	(mstack[fp-2].sfra)
+#define PREVSP	(fp-4)
+#define PREVFP	(mstack[fp-3].sfra)
Index: tokenizer.l
===================================================================
--- tokenizer.l	(revision 0)
+++ tokenizer.l	(revision 0)
@@ -0,0 +1,97 @@
+%{
+/* $OpenBSD: tokenizer.l,v 1.6 2008/08/21 21:00:14 espie Exp $ */
+/*
+ * Copyright (c) 2004 Marc Espie <espie@cvs.openbsd.org>
+ *
+ * Permission to use, copy, modify, and distribute this software for any
+ * purpose with or without fee is hereby granted, provided that the above
+ * copyright notice and this permission notice appear in all copies.
+ *
+ * THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES
+ * WITH REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF
+ * MERCHANTABILITY AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR
+ * ANY SPECIAL, DIRECT, INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES
+ * WHATSOEVER RESULTING FROM LOSS OF USE, DATA OR PROFITS, WHETHER IN AN
+ * ACTION OF CONTRACT, NEGLIGENCE OR OTHER TORTIOUS ACTION, ARISING OUT OF
+ * OR IN CONNECTION WITH THE USE OR PERFORMANCE OF THIS SOFTWARE.
+ */
+#include "parser.h"
+#include <stdlib.h>
+#include <errno.h>
+#include <stdint.h>
+#include <limits.h>
+
+extern int mimic_gnu;
+extern int32_t yylval;
+
+int32_t number(void);
+int32_t parse_radix(void);
+%}
+
+delim 	[ \t\n]
+ws	{delim}+
+hex	0[xX][0-9a-fA-F]+
+oct	0[0-7]*
+dec	[1-9][0-9]*
+radix	0[rR][0-9]+:[0-9a-zA-Z]+
+
+%%
+{ws}			{/* just skip it */}
+{hex}|{oct}|{dec}	{ yylval = number(); return(NUMBER); }
+{radix}			{ if (mimic_gnu) {
+				yylval = parse_radix(); return(NUMBER);
+			  } else {
+			  	return(ERROR);
+			  }
+			}
+"<="			{ return(LE); }
+">="			{ return(GE); }
+"<<"			{ return(LSHIFT); }
+">>"			{ return(RSHIFT); }
+"=="			{ return(EQ); }
+"!="			{ return(NE); }
+"&&"			{ return(LAND); }
+"||"			{ return(LOR); }
+.			{ return yytext[0]; }
+%%
+
+int32_t
+number()
+{
+	long l;
+
+	errno = 0;
+	l = strtol(yytext, NULL, 0);
+	if (((l == LONG_MAX || l == LONG_MIN) && errno == ERANGE) ||
+	    l > INT32_MAX || l < INT32_MIN) {
+		fprintf(stderr, "m4: numeric overflow in expr: %s\n", yytext);
+	}
+	return l;
+}
+
+int32_t
+parse_radix()
+{
+	long base;
+	char *next;
+	long l;
+
+	l = 0;
+	base = strtol(yytext+2, &next, 0);
+	if (base > 36 || next == NULL) {
+		fprintf(stderr, "m4: error in number %s\n", yytext);
+	} else {
+		next++;
+		while (*next != 0) {
+			if (*next >= '0' && *next <= '9')
+				l = base * l + *next - '0';
+			else if (*next >= 'a' && *next <= 'z')
+				l = base * l + *next - 'a' + 10;
+			else if (*next >= 'A' && *next <= 'Z')
+				l = base * l + *next - 'A' + 10;
+			next++;
+		}
+	}
+	return l;
+}
+
